/****************************************************************************/
/*              Red Flags and Red Herrings in the Execution Plans           */
/*                                                                          */
/*                         Dmitri V. Korotkevitch                           */
/*                        http://aboutsqlserver.com                         */
/*                          dk@aboutsqlserver.com                           */
/****************************************************************************/
/*						         Index Seek                                 */
/****************************************************************************/
set nocount on
go

use SQLServerInternals
go

-- Enable "Include Execution Plan"

set statistics io on
select count(*) from dbo.Orders with (index=1);
select count(*) from dbo.Orders with (index=1) where OrderID > 0;
set statistics io off
go

-- Scan is not always scanning all index
set statistics io on
select top 3 * from dbo.Orders order by OrderNum;
set statistics io off
go

set statistics io, time on
exec dbo.GetSalesByState @State = 'FL', @StartDate = '2019-06-01', @EndDate = '2019-07-01';
set statistics io, time off
go

/* 
create nonclustered index IDX_Orders_CustomerId
on dbo.Orders(CustomerId)
include(OrderDate,Amount);
*/

create nonclustered index IDX_Orders_CustomerId_OrderDate
on dbo.Orders(CustomerId, OrderDate)
include(Amount);
go

-- Compiling inefficient plan for @State = 'FL'
exec dbo.GetSalesByState @State = 'MA', @StartDate = '2019-06-01', @EndDate = '2019-07-01';
go

set statistics io, time on
exec dbo.GetSalesByState @State = 'FL', @StartDate = '2019-06-01', @EndDate = '2019-07-01';
set statistics io, time off
go

drop index IDX_Orders_CustomerId_OrderDate on dbo.Orders;
go
